#include <bits/stdc++.h>

using namespace std;

int main()
{
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,q;
    cin >> n >> q;
    string s;
    cin >> s;
    vector<int> v(0);
    for(int i = 0; i < q; i++){
        int a,b;
        cin >> a >> b;
        v.push_back(int((b-a+1)*(b-a+1)/4));
    }
    for(int x : v){
        cout << x << endl;
    }
}